diff -Nru darkice-1.2/src/VorbisLibEncoder.cpp darkice-1.3/src/VorbisLibEncoder.cpp
--- darkice-1.2/src/VorbisLibEncoder.cpp	2013-07-15 07:50:42.000000000 +0200
+++ darkice-1.3/src/VorbisLibEncoder.cpp	2015-05-18 19:38:07.000000000 +0200
@@ -5,9 +5,9 @@
    Tyrell DarkIce
 
    File     : VorbisLibEncoder.cpp
-   Version  : $Revision: 553 $
-   Author   : $Author: rafael@riseup.net $
-   Location : $HeadURL: https://darkice.googlecode.com/svn/darkice/tags/darkice-1_2/src/VorbisLibEncoder.cpp $
+   Version  : $Revision$
+   Author   : $Author$
+   Location : $HeadURL$
    
    Copyright notice:
 
@@ -40,7 +40,7 @@
 #include "Exception.h"
 #include "Util.h"
 #include "VorbisLibEncoder.h"
-
+#define VORBIS_MIN_BITRATE 45
 
 /* ===================================================  local data structures */
 
@@ -50,7 +50,7 @@
 /*------------------------------------------------------------------------------
  *  File identity
  *----------------------------------------------------------------------------*/
-static const char fileid[] = "$Id: VorbisLibEncoder.cpp 553 2013-07-15 05:50:56Z rafael@riseup.net $";
+static const char fileid[] = "$Id$";
 
 
 /* ===============================================  local function prototypes */
@@ -79,6 +79,15 @@
                          getInChannel() );
     }
 
+    if ( getOutBitrateMode() == abr || getOutBitrateMode() == cbr ) {
+        if ( getOutBitrate() < VORBIS_MIN_BITRATE ) {
+            throw Exception( __FILE__, __LINE__,
+                            "output bitrate is lower than libvorbis minimum",
+                            getOutBitrate() );
+        }
+        
+    }
+
     if ( getOutSampleRate() == getInSampleRate() ) {
         resampleRatio = 1;
         converter     = 0;
@@ -291,13 +300,13 @@
             if ( bitsPerSample == 8 ) {
                 char          * buf8 = (char *) buf;
                 unsigned int    ix   = sampleSize * i;
-		unsigned int    iix  = ix;
+                unsigned int    iix  = ix;
                 buf8[i] = (buf8[ix] + buf8[++iix]) / 2;
             }
             if ( bitsPerSample == 16 ) {
                 short         * buf16 = (short *) buf;
                 unsigned int    ix    = (bitsPerSample >> 3) * i;
-		unsigned int    iix   = ix;
+                unsigned int    iix   = ix;
                 buf16[i] = (buf16[ix] + buf16[++iix]) / 2;
             }
         }
@@ -361,6 +370,7 @@
     }
 
     delete[] shortBuffer;
+    
     vorbisBlocksOut();
 
     return processed;
@@ -402,7 +412,7 @@
             ogg_stream_packetin( &oggStreamState, &oggPacket);
 
             while ( ogg_stream_pageout( &oggStreamState, &oggPage) ) {
-                int    written;
+                int    written = 0;
                 
                 written  = getSink()->write(oggPage.header, oggPage.header_len);
                 written += getSink()->write( oggPage.body, oggPage.body_len);
diff -Nru darkice-1.2/src/VorbisLibEncoder.h darkice-1.3/src/VorbisLibEncoder.h
--- darkice-1.2/src/VorbisLibEncoder.h	2013-07-15 07:50:42.000000000 +0200
+++ darkice-1.3/src/VorbisLibEncoder.h	2016-08-03 22:18:36.000000000 +0200
@@ -5,22 +5,22 @@
    Tyrell DarkIce
 
    File     : VorbisLibEncoder.h
-   Version  : $Revision: 553 $
-   Author   : $Author: rafael@riseup.net $
-   Location : $HeadURL: https://darkice.googlecode.com/svn/darkice/tags/darkice-1_2/src/VorbisLibEncoder.h $
-   
+   Version  : $Revision$
+   Author   : $Author$
+   Location : $HeadURL$
+
    Copyright notice:
 
     This program is free software; you can redistribute it and/or
-    modify it under the terms of the GNU General Public License  
+    modify it under the terms of the GNU General Public License
     as published by the Free Software Foundation; either version 3
     of the License, or (at your option) any later version.
-   
+
     This program is distributed in the hope that it will be useful,
-    but WITHOUT ANY WARRANTY; without even the implied warranty of 
-    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
-   
+
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
@@ -51,7 +51,7 @@
 #include "Exception.h"
 #include "Reporter.h"
 #include "AudioEncoder.h"
-#include "CastSink.h"
+#include "Sink.h"
 #ifdef HAVE_SRC_LIB
 #include <samplerate.h>
 #else
@@ -71,8 +71,8 @@
  *  A class representing the ogg vorbis encoder linked as a shared object or
  *  as a static library.
  *
- *  @author  $Author: rafael@riseup.net $
- *  @version $Revision: 553 $
+ *  @author  $Author$
+ *  @version $Revision$
  */
 class VorbisLibEncoder : public AudioEncoder, public virtual Reporter
 {
@@ -199,7 +199,7 @@
          *  @exception Exception
          */
         inline
-        VorbisLibEncoder (  CastSink      * sink,
+        VorbisLibEncoder (  Sink          * sink,
                             unsigned int    inSampleRate,
                             unsigned int    inBitsPerSample,
                             unsigned int    inChannel,
@@ -211,11 +211,11 @@
                             unsigned int    outChannel    = 0,
                             unsigned int    outMaxBitrate = 0 )
                                                         throw ( Exception )
-            
+
                     : AudioEncoder ( sink,
                                      inSampleRate,
                                      inBitsPerSample,
-                                     inChannel, 
+                                     inChannel,
                                      inBigEndian,
                                      outBitrateMode,
                                      outBitrate,
@@ -244,7 +244,7 @@
          *  @exception Exception
          */
         inline
-        VorbisLibEncoder (  CastSink              * sink,
+        VorbisLibEncoder (  Sink                  * sink,
                             const AudioSource     * as,
                             BitrateMode             outBitrateMode,
                             unsigned int            outBitrate,
@@ -253,7 +253,7 @@
                             unsigned int            outChannel    = 0,
                             unsigned int            outMaxBitrate = 0 )
                                                             throw ( Exception )
-            
+
                     : AudioEncoder ( sink,
                                      as,
                                      outBitrateMode,
@@ -331,7 +331,7 @@
         }
 
         /**
-         *  Check wether encoding is in progress.
+         *  Check whether encoding is in progress.
          *
          *  @return true if encoding is in progress, false otherwise.
          */
@@ -402,7 +402,11 @@
                 return false;
             }
 
-            return getSink()->canWrite(sec, usec);
+            if ( 1 == vorbis_analysis_blockout( &vorbisDspState, &vorbisBlock) ) {
+              return getSink()->canWrite(sec, usec);
+            } else {
+              return true;
+            }
         }
 
         /**
@@ -447,4 +451,3 @@
 
 
 #endif  /* VORBIS_LIB_ENCODER_H */
-
